#include "msp430fr5739.h"
#include "FR_EXP.h"

const unsigned char LED_Menu[] = {0x80,0xC0,0xE0,0xF0};

unsigned char pj_outdat;		// P3o̓f[^
unsigned char p3_outdat;		// PJo̓f[^
volatile unsigned char yuigon[8];	// W[`FbNp̈⌾f[^


extern void LongDelay(void);

//
// TXyh
//@1)X^bNɃWX^ނޔ
//@2)X^bN|C^0xD000ɑޔ
//@3)RAMf[^0xD400ȍ~ɑޔ
//@4)⌾f[^c
//@5)[vēd؂̂҂
//
void zero_suspend(void)
{
	asm(";*****");
	asm(
		"\tPUSH  R2\n"
		"\tPUSHM.A #12,R15\n"
		"\tMOV.W #0xd000,R12\n"
		"\tMOV.W R1,0x0000(R12)\n"

		"\tMOV.W #0x1c00,R11\n"
		"\tMOV.W #0xd400,R12\n"
		"_LOOP:\n"
		"\tMOV.W 0x0000(R11),R13\n"
		"\tMOV.W R13,0x0000(R12)\n"
		"\tINC.W R11\n"
		"\tINC.W R12\n"
		"\tCMP.W #0x2000,R11\n"
		"\tJNE   _LOOP\n"
	);
	yuigon[0] = 'C';
	yuigon[1] = 'Q';
	yuigon[2] = ' ';
	yuigon[3] = 'P';
	yuigon[4] = 'u';
	yuigon[5] = 'b';
	yuigon[6] = '.';
	yuigon[7] = '\n';
	while(1)
	 ;
}


//
//@W[
//@TXyhɃZ[uĂX^bN|C^0xD000o
//@WX^ނ𕜋Aă^[
//@zero_suspend()̌Ăяoɖ߂邱ƂɂȂB
//@
void zero_resume()
{
	asm(
		"\tMOV.W #0xd000,R13\n"
		"\tMOV.W 0x0000(R13),R12\n"
		"\tMOV.W R12,R1\n"
		"\tPOPM.A #12,R15\n"
		"\tPOP  R2\n"
	);
}

void led_pj(unsigned char dat)
{
	pj_outdat = dat;
	PJOUT = dat;
}

void led_p3(unsigned char dat)
{
	p3_outdat = dat;
	P3OUT = dat;
}


unsigned char sw1()
{
	return(~P4IN & BIT0);
}

unsigned char sw2()
{
	return(~P4IN & BIT1);
}

void chk_suspend()
{
	unsigned char c;
	if (sw2()) {
		zero_suspend();			// TXyhԂɂȂ
		for (c=0; c<8; c++)		// W[̃X^[gʒu
			yuigon[c] = 0x00;	// W[̂ŁA⌾Ă
		led_pj(pj_outdat);		// LED̏Ԃ߂Ă
		led_p3(p3_outdat);
		for (c=0; c<50; c++)		// ҂ĂX^[g
			LongDelay();
	}
}

void smain(void)
{
	unsigned char c,d; 

	while(!sw1())
	;

	while(1) {
		for (c=0; c<4; c++) {
			led_pj(1 << c);
			chk_suspend();
			LongDelay();
		}
		led_pj(pj_outdat &= ~(BIT0 +BIT1+BIT2+BIT3));
		for (; c<8; c++) {
			led_p3(1 << c);
			chk_suspend();
			LongDelay();
		}
		led_p3(p3_outdat &= ~(BIT4 +BIT5+BIT6+BIT7));
	}
}


//
void init_var()
{
	led_pj(0);
	led_p3(0);
}


void main(void)
{
	WDTCTL = WDTPW + WDTHOLD;		// Stop WDT  
	SystemInit();				// Init the Board
	while(1) {
		if (!sw1()) {			// SW1͉ĂȂ
			if(					// ⌾cĂH
				(yuigon[0] == 'C') &&
				(yuigon[1] == 'Q') &&
				(yuigon[2] == ' ') &&
				(yuigon[3] == 'P') &&
				(yuigon[4] == 'u') &&
				(yuigon[5] == 'b') &&
				(yuigon[6] == '.') &&
				(yuigon[7] == '\n')
			) {
				zero_resume();			// ȂAW[
				while(1)			// ߂Ă鎖͖ǁAÔ
				;
			}
		}			// SW1ONĂ邩A⌾Ȃ珉X^[g
		init_var();		// O[oϐ
		led_pj(0x03);
		asm(
			"\tmov.w #0xd100,R1\n"		// X^bN0xD100ɎĂ
		);
		smain();
		while(1)
		;
	}
}
 
